function [mv_mpP]=MPDMultiVesselEpisodic_cc2(sampling_freq,channel,stimorder);
%opens MPD file, gets xdimension to scan over from user input, makes window size
%sampling_freq - (in Hz)
%channel - pmt channel to use, usually 1
%stimorder- order of stimuli, vector of 0(control) and 1's (stim)] 
%structures are mv_mpP, with mpP substructs
%pjd 4/11
my_crunched_folder='F:\data\crunched\'

matfilename=[];
[filename,pathname]=uigetfile('*.MPD','pick a linescan file')%loads file
try
[matfilename,matpathname]=uigetfile('*.mat','pick a .mat data file, cancel if none')%loads file
catch
matfilename='';
end
cd(pathname)
%display a file
[xstart, xstop,frames_hold,nframes,vessel_ID,depths,scan_type]=MPD_Display_Frames_MultiVessel(filename,matfilename,channel);
nvessels=length(xstart);
user_microns_per_pixel=input('microns per pixel @ 1x(20x~0.62 40x~0.32:');
start_frame=input('start frame: ');
%endframe=input('end frame: ');
the_decimate=1;%input('decimation factor: ');
the_objective=input('objective: [1] 40x Olympus; [2] 20x: [3] 20x 0.95NA');
animal=input('animal?','s');
isinterleaved=0;
stimulus=0;%input('stimulus 1)puff 2)noise')
nframes=input('# frames trial?');
ntrials=input('# trials?');
depth=input('depth?');
stimtime=input('stim start?');
max_v=20000;%input('maximum velocity, in micrometers/sec: ')
windowsize=1/(sampling_freq);

angle_span=10;%number of degrees (+/-) around previous angle to look
angle_resolution=.05;%how accurate to determine the angle
the_scanmirrors=input('which mirrors? 1)6210(fast) 2)6215(slow)');
vessel=input('vessel  ID?','s');
channel=1;
for v=1:nvessels

if (scan_type(v)==1)%get velocity
    [mpP, function_ID]=GetVelocityRadon_Episodic_L4_cc(filename,matfilename,...-
    [start_frame:nframes:nframes*ntrials],windowsize,angle_span, angle_resolution,[xstart(v) xstop(v)],...
    the_decimate,max_v,user_microns_per_pixel,channel);%
try    
mpP.velocity_code=GetFunctionCode(function_ID);
end
end
if (scan_type(v)==0)%get diameter
    [mpP,function_ID]=GetDiameter_Episodic_L5_cc(filename,matfilename,...
    [start_frame:nframes:nframes*ntrials],windowsize,[xstart(v) xstop(v)],...
    the_decimate,user_microns_per_pixel,channel);
try
    mpP.diameter_code=GetFunctionCode(function_ID);
end
end
if the_scanmirrors==1
    mpP.the_scan_mirrors=6210;
elseif the_scanmirrors==2
    mpP.the_scan_mirrors=6215;
end

mpP.the_stim=stimorder;
mpP.animal=animal;
mpP.vessel=vessel;
mpP.clock=clock;
mpP.the_objective=the_objective;
mpP.stimtime=stimtime;
the_date=date;
mpP.depth=depth;
if v>1
[mpP,mv_mpP]=MatchStructs(mpP,mv_mpP)
end
mv_mpP(v)=mpP;
end

try
    plot_mv_mpP_Episodic(mv_mpP,20,11)
end
try
save_filename=[animal '_' vessel 'mv_mpP_' filename(1:end-4) '_' the_date];
save(save_filename,'mv_mpP')
catch
disp('save failed!')    
end
%[mpP]=EvokedVelocityPlot6(mpP, 101, 2, mpP.the_stim+1);
try 
save(save_filename,'mv_mpP')
save([my_crunched_folder save_filename],'mv_mpP')
catch
disp('crunched folder save failed!')        
end

%EvokedVelocityPlot2(mpP);